#!/usr/bin/perl

# applydiff.pl
# Brian Walters - 3/2/2
# This script is intended to apply .diff files to the squidguard blacklist files.
# If you wish to keep your own local .diff file is should be labeled as .local.diff
#
# Improvements are welcomed


$datafile=$ARGV[0];

if ( $datafile=~/(.*)\/{1,}(.*)/ ) {
	$datadir=$1;
	$datafile=$2;
} else {
	$datadir="./";
}

#print "changing to directory: $datadir\n";
chdir $datadir;

open DATA, "<$datafile" or die "Unable to open file: $datafile\n";

my %domains;
my %diffs;


while (<DATA>) {
	chomp;
	unless ( $_=~/^$/ ) {
		$domains{$_}=$_;		
	}
}

close DATA;




opendir DIR, "./" || die "can't opendir: $!";
@diff_files = grep { /$datafile.*\.diff/ } readdir(DIR);
closedir DIR;


foreach $diff_file (@diff_files) {
	open DIFF, "<$diff_file" or die "Unable to open file: $diff_file\n";


	while (<DIFF>) {
		$_ =~ /([-+])(.*)/;
	
		$action=$1;
		$domain=$2;
	
		if ( $action =~ /\+/ ) {
			# add the domain
			#unless ( grep(/^$domain$/, @domains) ) {
			#	push(@domains,$domain);
			#}
			unless ( $domains{$domain} ) {
				$domains{$domain}=$domain;
			}
		} else {
			$diffs{$domain}=$domain;
		}
	}
	close DIFF;
}

@domains = keys %domains;

open DATA, ">$datafile" or die "Unable to open file: $datafile\n";

foreach $domain (@domains) {
	unless ($diffs{$domain}) {
		print DATA "$domain\n";
	}
}

close DATA;

